# nodeid-php

NodeID is a network service for generating unique ID numbers at high scale with some simple guarantees.

This is a C version for php extension.

### Performance

    * minimum 10k ids per second per process

-   response rate 2ms (plus network latency)

### System Clock Dependency

    You should use NTP to keep your system clock accurate.  Snowflake protects from non-monotonic clocks, i.e. clocks that run backwards.  If your clock is running fast and NTP tells it to repeat a few milliseconds, snowflake will refuse to generate ids until a time that is after the last time we generated an id. Even better, run in a mode where ntp won't move the clock backwards. See http://wiki.dovecot.org/TimeMovedBackwards#Time_synchronization for tips on how to do this.

## building

    To build and test

    ```shell
    cd ext-nodeid
    phpize
    ./configure
    make && make install
    ```
    To use unique in php:

    ```php

    echo nodeid();

    ```
    And U can add server id into PHP.ini（Optional）:
    ```php

    [nodeid]
    nodeid.server_id = 10

    ```
