#ifndef SID_H
#define SID_H

#include <stdio.h>
#include <pthread.h>
#include <unistd.h>
#include <stdlib.h>
#include <sched.h>
#include <linux/unistd.h>
#include <sys/syscall.h>
#include <errno.h>
#include <linux/types.h>
#include <time.h>
#include <stdint.h>
#include <sys/time.h>

//2010/11/4 9:42:54 twitter version timestamp
#define twepoch 1288834974657L

struct snowflake_data {
	uint64_t lastTimestamp;
	long datacenterId;
	long workerId;
	int sequence;
};

#ifdef ZTS
# include "TSRM.h"
TSRMLS_D;
extern TSRM_TLS struct snowflake_data *tsrm_ls_mData;
void ts_allocate_ls(void);
void ts_free_ls(void);
#define mData (*tsrm_ls_mData)
#else
extern struct snowflake_data mData;
#endif

void set_workid(long myworkid);
void set_datacenterId(long datacenterId);
uint64_t timeGen();
uint64_t tilNextMillis(uint64_t lastStamp);
pid_t get_pid(void);
int atomic_incr(int *id);
uint64_t get_twitter_id(uint64_t timestamp);

#endif // SID_H
