<?php

function storeNodeID(string $licFile) : void {

	static $once;

	if (! is_null($once)) {
		throw new BadMethodCallException(__FUNCTION__.' should only be called once');
	}
	$once = TRUE;
	$mod = 'nodeid';

	if (! extension_loaded($mod)) {
		logWarn(sprintf("Module '%s' missing -> cannot store NodeID in %s", $mod, $licFile));
		return;
	}

	if (! file_exists($licFile)) {

		$nodeInfo = sid();
		$out = [
			'timestamp' => $nodeInfo{'timestamp'},
			'seed'		=> $nodeInfo['seed'],
			'serverid'	=> $nodeInfo['serverid']
		];

		file_put_contents($licFile, json_encode($out));
		define('ELY_NODE_ID', $nodeInfo['node_id']);

	} else {

		$nodeInfo = json_decode(file_get_contents($licFile));
		define('ELY_NODE_ID', $nodeInfo['node_id']);
	}

	logInfo('NodeID: '.ELY_NODE_ID);
}


